DEFINE	ONINT_USED	1
DEFINE OSC 10
'PLEASE NOTE
' ************** This code is written for a PIC16F876 operating on 3.3volts **************
@ device pic16F876, xt_osc, wdt_on, pwrt_off, bod_off, lvp_off, cpd_off, wrt_off, protect_off
' ****************************************************************************************
SPBRG=0				'************ NOTE ***********
RCSTA=0				'This is required if you are using
TXSTA=2				'Shane Tolmie's bootloader (PICLoader)
				'*****************************
ADCON1	= 7

dat	     var 	PORTD
chr      var    byte
scl	     var 	PORTC.3		'I2C SCL  for ext eeprom 
sda	     var	PORTC.4		'I2C SDA for ext eeprom
ctl      con    $A0		'EEPROM control code
addr	 var	WORD		'EEPROM address		
edata	 var	BYTE		'Data byte to be written
i	     var    BYTE            'General variable used for loops
edata     =      0
addr      =      0
err      var    WORD
'Serial Pins
out_pin	 var	PORTC.6		'Serial OUT pin
in_pin	 var    PORTC.7		'Serial IN pin
ser_baud con	32		'19200 Baud

serout2 PORTC.6,32,["I2CEeprom read/write check",10,13]
serout2 PORTC.6,32,["Writing 8k bytes to eeprom.....",10,13]

chr = $21
for addr = 0 to 8191
  serout2 PORTC.6,32,[chr," "]
  I2CWRITE sda,scl,ctl,addr,[chr]
  'pause 5    'ONLY required  if using regular eeproms and not FRAMS
  chr = chr + 1
  if chr > $7f then chr = $21
next addr
err = 0
chr = $21
serout2 PORTC.6,32,[10,13,"Read & compare 8k bytes from eeprom.....",10,13]
pause 3000
for addr = 0 to 8191
  'serout2 PORTC.6,84,[chr," "]
  I2CREAD sda,scl,ctl,addr,[edata]
   if edata <> chr then
       serout2 PORTC.6,32,["Error! "]
       err = err + 1 
     else  
       serout2 PORTC.6,32,[edata," "] 
   endif
  chr = chr + 1
  if chr > $7f then chr = $21
next addr

serout2 PORTC.6,32,[10,13,"End of Test ", DEC err," Errors",10,13]
'End of Program
loop:
goto loop
end
